#include <stdio.h>

#include <stdarg.h>

#define DBGI(a) printf(#a " ==> %d\n", a)
#define DBGF(a) printf(#a " ==> %f\n", a)

int test (int, ... );

int main (int argc, char ** argv) {

  double b;
  int a, val;

  a = 1;
  b = 3.0;

  test (val, a, b);
  
  return 0;
}

int test (int val, ...) {

  va_list ap;
  double b;
  int a;

  va_start (ap, val);

  /* vengono estratti dallo stack secondo l'ordine in cui sono stati passati */

  a = va_arg (ap, int);
  b = va_arg (ap, double);

  DBGI(a);
  DBGF(b);

  va_end (ap);

  return 0;
}
